unit FrmMainTestGui;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, IdHTTP, IdCompressionIntercept, IdCompressorZLib,
  IdSSLOpenSSL, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnGet: TButton;
    btnPost: TButton;
    edUrl: TEdit;
    http: TIdHTTP;
    IdCompressorZLib1: TIdCompressorZLib;
    IdSSLIOHandlerSocketOpenSSL1: TIdSSLIOHandlerSocketOpenSSL;
    memRecv1: TMemo;
    memRecvHeaders1: TMemo;
    memSend: TMemo;
    memSendHeaders: TMemo;
    Panel1: TPanel;
    pnlRecv1: TPanel;
    pnlSend: TPanel;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    procedure btnGetClick(Sender: TObject);
    procedure btnPostClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    procedure HttpGet;

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.btnGetClick(Sender: TObject);
begin
  HttpGet;
end;

procedure TForm1.btnPostClick(Sender: TObject);
begin
  ShowMessage('not handled yet because get does not work');
end;

procedure TForm1.HttpGet;
var MyResponse: TMemoryStream;
begin
  MyResponse := nil;
  try
    http.HandleRedirects := True;
    // If you put this - Compressor zlib should extract received gzip and
    // return plain string in response
    // this does not happen with Indy CT570 - but it is OK with Indy CT540
    // so I think something is wrong with ungzip routine
    http.Request.AcceptEncoding := 'deflate, gzip, utf-8';
    http.Request.CacheControl := 'no-store';
    http.Request.Pragma := 'no-cache';
    http.Request.Connection := 'keep-alive';

    MyResponse := TMemoryStream.Create;
    http.Get(edUrl.Text, MyResponse);
    MyResponse.SaveToFile('memget.txt');
    memRecv1.Lines.LoadFromFile('memget.txt');
    memSendHeaders.Text := http.Request.RawHeaders.Text;
    memRecvHeaders1.Text := http.Response.RawHeaders.Text;
    if MyResponse <> nil then FreeAndNil(MyResponse);
  except
    on E: Exception do begin
      if MyResponse <> nil then FreeAndNil(MyResponse);
    end;
  end;

end;

end.

